#include <iostream>

using namespace std;

int main()
{
    int n, q;
    cin>>n>>q;
    int Direktan_napad[n], Otrovan_napad[n], Hp[q];
    for(int i=0;i<n;i++)
    {
        cin>>Direktan_napad[i]>>Otrovan_napad[i];
    }
    for(int i=0;i<q;i++)
    {
        cin>>Hp[i];
    }
    for(int i=0;i<q;i++)
    {
        unsigned otrov_po_potezu=0, potezi=0;

        for(int j=0;j<n;j++)
        {
            if(Direktan_napad==0)
                otrov_po_potezu+=Otrovan_napad[j];
            else
            {
                Hp[i]-=Direktan_napad[j];
            }
            Hp[i]-=otrov_po_potezu;
            potezi++;
            if(Hp[i]<=0)
            {
                cout<<potezi<<endl;
                j=n;
            }
        }
    }

    return 0;
}